routes/admin.php
<?php
// Admins routes
Route::group(['middleware' => ['auth', 'Admin']], function () {
    Route::resource('/leads', 'LeadController');
    Route::post('/leads/assigned', 'LeadController@assigned')
        ->name('leads.assigned');
    Route::get('/leads/ajax/table', 'LeadController@table')->name('leads.table');

    Route::get('/calls/create/{lead}', 'CallController@create')
        ->name('calls.create');
    Route::post('/call/{lead}', 'CallController@store')
        ->name('calls.store');

    
});

routes/web.php
<?php

Route::get('/', function () {
    return view('welcome');
});

Auth::routes();

require_once 'admin.php';
require_once 'teamLeader.php';
require_once 'sales.php';


// Errors
Route::get('/403', function () {
    return view('errors.403');
})->name('403');

Route::get('/get-sales/{lead}', 'LeadController@updateSalesByLeadId');

app/Lead.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class Lead extends Model
{
    public function sales()
    {
        return $this->belongsTo(User::class, 'sales_id');
    }
}

app/Http/Controllers/API/LeadController.php
<?php

namespace App\Http\Controllers\API;

use App\Lead;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Validator;
use Illuminate\Validation\Rule;

class LeadController extends Controller
{
    public function index()
    {
        return Lead::paginate(5);
    }

    public function show(Lead $lead)
    {
        return $lead;
    }

    public function store(Request $request)
    {
        // validation
        $validator = Validator::make($request->all(), [
            'name'=> 'required|string',
            'phone'=> ['required'],
            'email'=> ['email'],
            'address'=> 'required',
        ]);

        if ($validator->fails()) {
            return [
                'status'=> 405,
                'errors'=>$validator->errors()
            ];
        }

        $lead = new Lead();
        $lead->name = $request->input('name');
        $lead->phone = $request->input('phone');
        $lead->email = $request->input('email');
        $lead->address = $request->input('address');

        $lead->save();
        return $lead;
    }


    public function update(Request $request, Lead $lead)
    {
        // validation
        $validator = Validator::make($request->all(), [
            'name'=> 'required|string',
            'phone'=> [
                'required',
                Rule::unique('leads')->ignore($lead)
            ],
            'email'=> [
                'email',
                Rule::unique('leads')->ignore($lead),
            ],
            'address'=> 'required',
        ]);

        if ($validator->fails()) {
            return [
                'status'=> 405,
                'errors'=>$validator->errors()
            ];
        }
        
        $lead->name = $request->input('name');
        $lead->phone = $request->input('phone');
        $lead->email = $request->input('email');
        $lead->address = $request->input('address');

        $lead->save();
        return $lead;
    }
}

app/Http/Controllers/LeadController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\LeadRequest;
use App\Lead;
use App\Role;
use App\User;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\URL;
use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Validator;


class LeadController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return view
     */
    public function index()
    {
//        $leads = DB::table('leads')
//            ->join('users', 'users.id', '=', 'leads.sales_id')
//            ->select('users.name as u_name', 'leads.name as l_name')
//            ->get();
//
//        dd($leads);
        $table = view('backoffice.leads.table', [
            'leads'=> Lead::where('status', 1)->orderBy('name')->paginate(10),
        ]);

        return view('backoffice.leads.index', ['table'=> $table]);
    }
    
    public function table()
    {
        return view('backoffice.leads.table', [
            'leads'=> Lead::where('status', 1)->orderBy('name')->paginate(10),
        ]);
    }

    public function updateSalesByLeadId(Lead $lead)
    {
        return view('backoffice.leads.sales-options', [
            'sales'=> User::getAllSales(),
            'lead'=> $lead
        ]);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('backoffice.leads.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(LeadRequest $request)
    {
        $lead = new Lead();
        $lead->name = $request->input('name');
        $lead->phone = $request->input('phone');
        $lead->email = $request->input('email');
        $lead->address = $request->input('address');

        if($lead->save()){
            return [
                'status'=> 200,
                'message'=> 'saved'
            ];
        } else {
            return [
                'status'=> 400,
                'message'=> 'not valid'
            ];
        }
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Lead  $lead
     * @return \Illuminate\Http\Response
     */
    public function show(Lead $lead)
    {
        return view('backoffice.leads.show', ['lead'=> $lead]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Lead  $lead
     * @return \Illuminate\Http\Response
     */
    public function edit(Lead $lead)
    {
        return view('backoffice.leads.edit', ['lead'=> $lead]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Lead  $lead
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Lead $lead)
    {

        $validator = Validator::make($request->all(), [
            'name'=> 'required|string',
            'phone'=> [
                'required',
                Rule::unique('leads')->ignore($lead)
            ],
            'email'=> [
                'email',
                Rule::unique('leads')->ignore($lead),
            ],
            'address'=> 'required',
        ]);

        if ($validator->fails()) {
            return back()
                ->withErrors($validator);
        }

        $lead->name = $request->input('name');
        $lead->phone = $request->input('phone');
        $lead->email = $request->input('email');
        $lead->address = $request->input('address');

        $lead->save();
        return redirect()->route('leads.show', $lead);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Lead  $lead
     * @return \Illuminate\Http\Response
     */
    public function destroy(Lead $lead)
    {

        $lead->status = false;
        $lead->save();
        return back()->with('message', 'Deleted');
    }

    public function assigned(Request $request)
    {
        $lead = Lead::find($request->input('lead'));
        if ($request->input('sales') == 0) {
            $lead->sales_id = null;
        } else {
            $lead->sales_id = $request->input('sales');
        }
    
        if($lead->save()){
            return [
                'status'=> 200,
                'message'=> 'saved'
            ];
        } else {
            return [
                'status'=> 400,
                'message'=> 'not valid'
            ];
        }
    }
}

resources/views/backoffice/leads/create.blade.php
@extends('layouts.app')

@section('title', 'Leads')

@section('pageHeader', 'Create Lead')

@section('content')
    <form action="{{ route('leads.store') }}" method="post">
        @csrf
        @include('shared.input', [
                'name'=> 'name',
                'label'=> 'Name',
                'value'=> old('name')
                ])
        @include('shared.input', [
                'name'=> 'phone',
                'label'=> 'Phone',
                'value'=> old('phone'),
                'type'=> 'tel'
                ])
        @include('shared.input', [
                'name'=> 'email',
                'label'=> 'Email',
                'value'=> old('email'),
                'type'=> 'email'
                ])

        <div class="form-group">
            <label for="address">Address</label>
            <input type="text" class="form-control" name="address" id="address" value="{{ old('address') }}">
        </div>
        <div class="text-center">
            <button type="submit" class="btn btn-success">Save</button>
        </div>
    </form>
@endsection

resources/views/backoffice/leads/edit.blade.php
@extends('layouts.app')

@section('title', 'Leads')

@section('pageHeader', 'Edit Lead')

@section('content')
    <form action="{{ route('leads.update', $lead) }}" method="post">
        @csrf
        @method('PUT')
        <div class="form-group">
            <label for="name">Name</label>
            <input type="text" class="form-control" name="name" id="name" value="{{ $lead->name }}">
        </div>
        <div class="form-group">
            <label for="phone">Phone</label>
            <input type="tel" class="form-control" name="phone" id="phone" value="{{ $lead->phone }}">
        </div>
        <div class="form-group">
            <label for="email">Email</label>
            <input type="email" class="form-control" name="email" id="email" value="{{ $lead->email }}">
        </div>
        <div class="form-group">
            <label for="address">Address</label>
            <input type="text" class="form-control" name="address" id="address" value="{{ $lead->address }}">
        </div>
        <div class="text-center">
            <button type="submit" class="btn btn-success">Save</button>
        </div>
    </form>
@endsection

resources/views/backoffice/leads/index.blade.php
@extends('layouts.app')

@section('title', 'Leads')

@section('pageHeader', 'All Leads')

@section('content')

    <div class="text-right p-3">
        @if (Auth::user()->role->slug == 'ADM')
        <!-- <a href="{{ route('leads.create') }}" class="btn btn-success">ADD NEW</a> -->
        <button type="button"
                    class="btn btn-success"
                    data-toggle="modal"
                    data-target="#modal-new-lead">
                ADD NEW
            </button>
        @endif
    </div>
   <div id="lead-table-content">
    {!! $table !!}
   </div>


    <!-- Modals -->
    <div class="modal fade" id="modal-assigned" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Assigned Sales Man</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <form action="{{ route('leads.assigned') }}"
                      method="post"
                      class="text-center">
                    @csrf
                    <div class="modal-body">

                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Save changes</button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <div class="modal fade" id="modal-new-lead" tabindex="-1" role="dialog" aria-labelledby="exampleModalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Create New</h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>

                <div class="form-error">
                </div>

                <form action="{{ route('leads.store') }}" method="post">
                    @csrf
                    <div class="modal-body">
                        @include('shared.input', [
                                'name'=> 'name',
                                'label'=> 'Name',
                                'value'=> old('name')
                                ])
                        @include('shared.input', [
                                'name'=> 'phone',
                                'label'=> 'Phone',
                                'value'=> old('phone'),
                                'type'=> 'tel'
                                ])
                        @include('shared.input', [
                                'name'=> 'email',
                                'label'=> 'Email',
                                'value'=> old('email'),
                                'type'=> 'email'
                                ])

                        <div class="form-group">
                            <label for="address">Address</label>
                            <input type="text" class="form-control" name="address" id="address" value="{{ old('address') }}">
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Save changes</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
@endsection

resources/views/backoffice/leads/sales-options.blade.php
<input type="hidden" name="lead" value="{{ $lead->id }}">

<label for="sales">Sales</label>
    <select name="sales" id="sales" class="form-control">
        <option value=>Select Sales</option>
        @foreach($sales as $user)
            @if ($lead->sales_id == $user->id)
                <option value="{{ $user->id }}" selected>{{ $user->name }}</option>
            @else
                <option value="{{ $user->id }}">{{ $user->name }}</option>
            @endif
        @endforeach
    </select>
</form>

resources/views/backoffice/leads/show.blade.php
@extends('layouts.app')

@section('title', 'Leads')

@section('pageHeader', 'Show Lead')

@section('content')
    <h3><span class="text-bold">Name:</span> {{ $lead->name }}</h3>
    <p><span class="text-bold">Phone:</span> {{ $lead->phone }}</p>
    <p><span class="text-bold">Email:</span> {{ $lead->email }}</p>
    <p><span class="text-bold">Address:</span> {{ $lead->address }}</p>
    <div>
        <a href="{{ route('leads.edit', $lead) }}" class="btn btn-primary">Edit</a>
        <a href="{{ route('leads.destroy', $lead) }}" class="btn btn-danger">Delete</a>
    </div>

@endsection

resources/views/backoffice/leads/table.blade.php
<table class="table table-bordered">
    <thead>
    <tr>
        <th>#</th>
        <th>Name</th>
        <th>Phone</th>
        <th>Email</th>
        <th>Sales</th>
        <th>Actions</th>
    </tr>
    </thead>
    <tbody>
    @foreach($leads as $lead)
    <tr>
        <td>{{ $lead->id }}</td>
        <td>{{ $lead->name }}</td>
        <td>{{ $lead->phone }}</td>
        <td>{{ $lead->email }}</td>
        <td>{{ isset($lead->sales->name) ? $lead->sales->name : '' }}</td>
        <td>
            <a href="{{ route('leads.show', $lead) }}" class="btn btn-info">Show</a>
            <button type="button"
                    lead-id="{{ $lead->id }}"
                    class="btn btn-primary update-sales"
                    data-toggle="modal"
                    data-target="#modal-assigned">
                Update Sales Man
            </button>
            @if (Auth::user()->role->slug == 'ADM')
                {{--<button type="button" class="btn btn-primary" data-toggle="modal" data-target="#modal-assigned">--}}
                    {{--Assigned--}}
                {{--</button>--}}

            @endif
            @if (Auth::user()->role->slug == 'ADM')
                <a href="{{ route('leads.edit', $lead) }}" class="btn btn-primary">Edit</a>
                <form action="{{ route('leads.destroy', $lead) }}" method="post" style="display: inline-block">
                    @csrf
                    @method('DELETE')
                    <button type="submit" class="btn btn-danger">Delete</button>
                </form>
            @endif
            @if (
            Auth::user()->role->slug == 'ADM' ||
            Auth::user()->role->slug == 'TMLD' ||
            Auth::user()->role->slug == 'SAL'
            )
                <a href="{{ route('calls.create', $lead) }}" class="btn btn-primary">Call</a>
            @endif
        </td>
    </tr>
    @endforeach
    </tbody>
    {{ $leads->links() }}
</table>

resources/views/backoffice/leads/td-select-seales.blade.php
<td>
    {{--{!! $lead->sales? $lead->sales->name : '<span class="alert alert-danger">unassigned</span>' !!}--}}
    <form action="{{ route('leads.assigned') }}" method="post" class="text-center">
        @csrf
        <input type="hidden" name="lead" value="{{ $lead->id }}">
        <select name="sales" id="sales" class="form-control" required>
            <option value="0">Unassigned</option>
            @foreach($sales as $user)
                @if ($lead->sales && $lead->sales->id === $user->id)
                    <option value="{{ $user->id }}" selected>{{ $user->name }}</option>
                @else
                    <option value="{{ $user->id }}">{{ $user->name }}</option>
                @endif
            @endforeach
        </select>
        <button type="submit" class="btn btn-primary m-2">Save</button>
    </form>
</td>